package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.NavigationPackage;
import com.izouma.awesomeadmin.service.NavigationPackageService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * controller类
 */
@Controller
@RequestMapping("/navigationPackage")
public class NavigationPackageController {

    @Autowired
    private NavigationPackageService navigationPackageService;

    /**
     * <p>获取全部记录。</p>
     */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(NavigationPackage record) {
        List<NavigationPackage> pp = navigationPackageService.getNavigationPackageList(record);
        return new Result(true, pp);
    }

    /**
     * <p>根据Id。</p>
     */
    @RequestMapping(value = "/getNavigationPackage", method = RequestMethod.GET)
    @ResponseBody
    public Result getNavigationPackage(@RequestParam(required = false, value = "id") String id) {
        NavigationPackage data = navigationPackageService.getNavigationPackageById(id);
        return new Result(true, data);
    }

    /**
     * <p>根据条件获取。</p>
     */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(NavigationPackage record) {
        NavigationPackage data = navigationPackageService.getNavigationPackage(record);
        return new Result(true, data);
    }


    /**
     * <p>分页查询。</p>
     */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, NavigationPackage record) {
        Map<String, Object> result = new HashMap<>();

        List<NavigationPackage> pp = navigationPackageService.getNavigationPackageByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
     * <p>保存。</p>
     */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(NavigationPackage record) {
        boolean num = navigationPackageService.createNavigationPackage(record);
        if (num) {
            return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>更新信息。</p>
     */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateNavigationPackage(NavigationPackage record) {
        boolean num = navigationPackageService.updateNavigationPackage(record);
        if (num) {
            return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>删除。</p>
     */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteNavigationPackage(NavigationPackage record) {

        boolean num = navigationPackageService.deleteNavigationPackage(record);
        if (num) {
            return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
     * 导出Excel
     *
     * @param request
     * @param response
     * @param record
     * @throws Exception
     */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, NavigationPackage record) throws Exception {

        List<NavigationPackage> navigationPackages = navigationPackageService.getNavigationPackageList(record);


        String sheetName = "navigation_package";
        String titleName = "导航包数据表";
        String fileName = "导航包表";
        int columnNumber = 14;
        int[] columnWidth = {20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20};
        String[] columnName = {"ID", "删除标识", "更新时间", "更新人", "创建时间", "创建人", "地标ID", "标题", "描述", "是否付费", "价格", "点标", "排序", "是否上线"};
        String[][] dataList = new String[navigationPackages.size()][14];

        for (int i = 0; i < navigationPackages.size(); i++) {

            dataList[i][0] = String.valueOf(navigationPackages.get(i).getId());
            dataList[i][1] = String.valueOf(navigationPackages.get(i).getDelFlag());
            dataList[i][2] = String.valueOf(navigationPackages.get(i).getUpdateTime());
            dataList[i][3] = String.valueOf(navigationPackages.get(i).getUpdateUser());
            dataList[i][4] = String.valueOf(navigationPackages.get(i).getCreateTime());
            dataList[i][5] = String.valueOf(navigationPackages.get(i).getCreateUser());
            dataList[i][6] = String.valueOf(navigationPackages.get(i).getLandMarkId());
            dataList[i][7] = String.valueOf(navigationPackages.get(i).getName());
            dataList[i][8] = String.valueOf(navigationPackages.get(i).getRemark());
            dataList[i][9] = String.valueOf(navigationPackages.get(i).getPayFlag());
            dataList[i][10] = String.valueOf(navigationPackages.get(i).getPrice());
            dataList[i][11] = String.valueOf(navigationPackages.get(i).getAimPlace());
            dataList[i][12] = String.valueOf(navigationPackages.get(i).getRank());
            dataList[i][13] = String.valueOf(navigationPackages.get(i).getShelfFlag());
        }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
                columnNumber, columnWidth, columnName, dataList, response);


    }


    /**
     * 获取已经购买的导游包
     * @param record
     * @return
     */
    @RequestMapping(value = "/bought", method = RequestMethod.GET)
    @ResponseBody
    public Result bought(NavigationPackage record) {
        NavigationPackage data = navigationPackageService.getBoughtNavigationPackage(record);
        return new Result(true, data);
    }

}

